QXmppStream.h
/*
* Copyright (C) 2008-2014 The QXmpp developers
*
* Authors:
* Manjeet Dahiya
* Jeremy Lainé
*
* Source:
* https://github.com/qxmpp-project/qxmpp
*
* This file is a part of QXmpp library.
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
*/
#ifndef QXMPPSTREAM_H
#define QXMPPSTREAM_H
#include <QAbstractSocket>
#include <QObject>
#include "QXmppLogger.h"
class QDomElement;
class QSslSocket;
class QXmppStanza;
class QXmppStreamPrivate;
class QXMPP_EXPORT QXmppStream : public QXmppLoggable
{
Q_OBJECT
public:
QXmppStream(QObject *parent);
~QXmppStream();
virtual bool isConnected() const;
bool sendPacket(const QXmppStanza&);
signals:
void connected();
void disconnected();
protected:
// Access to underlying socket
QSslSocket *socket() const;
void setSocket(QSslSocket *socket);
// Overridable methods
virtual void handleStart();
virtual void handleStanza(const QDomElement &element) = 0;
virtual void handleStream(const QDomElement &element) = 0;
public slots:
virtual void disconnectFromHost();
virtual bool sendData(const QByteArray&);
private slots:
void _q_socketConnected();
void _q_socketEncrypted();
void _q_socketError(QAbstractSocket::SocketError error);
void _q_socketReadyRead();
private:
QXmppStreamPrivate * const d;
};
#endif // QXMPPSTREAM_H
QXmppStanza
The QXmppStanza class is the base class for all XMPP stanzas.
Definition: QXmppStanza.h:90
QXmppLoggable
The QXmppLoggable class represents a source of logging messages.
Definition: QXmppLogger.h:111
QXmppStream
The QXmppStream class is the base class for all XMPP streams.
Definition: QXmppStream.h:41